#include "Camera.h"


Camera::Camera()
{
	position = vec3(0.0f, 0.0f, 0.0f);
	matrix = glm::mat4();
	angleV = vec3(0.0, 0.0, 0.0);
}


Camera::~Camera()
{
}

bool Camera::Init()
{
	matrix = glm::lookAt(position,
		glm::vec3(0.0f,0.0f,1.0f),
		glm::vec3(0, 1, 0));
	return true;
}

void Camera::Translate(vec3 v)
{
	matrix = glm::translate(matrix,v);
	position -= v;
}

void Camera::Rotate(vec3 v, float angle)
{
	vec3 sp = position;

	matrix = glm::rotate(matrix, angle, v);
	position = vec3(vec4(position, 1.0f)*matrix);
}

void Camera::TranslateTo(vec3 p)
{
	vec3 p2 = position - p;
	matrix = glm::translate(matrix, -p2);
	position = p;
}

vec3 Camera::GetPosition()
{
	return position;
}

void Camera::SetPosition(vec3 v)
{
	position = v;
}