#pragma once
#include "dependences.h"
#include "Object.h"
class Model {
public:
	Model();
	~Model();
	bool LoadModel();
	bool SetAttributeLocation(GLuint prog, const GLchar* name, int type);
	bool Init(GLuint sh, bool withText);
	bool Draw(GLuint Unif_mat, Camera *view);
	void Translate(vec3 v);
	void Scalling(vec3 v);
	void Rotate(vec3 v, float an);
	void Model::SetProjection(float angle, float ratio, float first, float second);
	string modelName = "";
	string fileName = "";
	ModelSize ms;
private:
	vector<Object*> objects;	
	glm::vec3 ParseVertex(const char* buffer);
	glm::vec2 ParseTexture(const char* buffer);
	glm::vec3 ParseNormal(const char* buffer);
	glm::vec3 ParseIndex(const char* buffer, int type);
	void ParseMtlFile(string path);
	bool LoadModelFromObj(const char* file);
	GLuint shader;
	glm::mat4 matrix = mat4();
	glm::mat4 modelMatrix = mat4();
	glm::mat4 projectionMatrix = mat4();	
};