#pragma once 
#include "dependences.h"
#include "types.h"
class Object {
public:
	Object();
	Object(int vc, int tc, int ic);
	~Object();
	void Object::LoadVertexes(vec3 v1);
	void Object::LoadIndexes(vec3, int type);
	void Object::LoadNormal(vec3 n1);
	void Object::LoadTextures(vec2 t1);
	void CreateBuffers(bool withText);
	void Draw(GLuint program);
	void SetAttributeArrays(GLuint va, int type);
	string textureFile = "";
	bool useTexture = false;
private:
	vector<glm::vec3> vertecies;
	vector<glm::vec2> texture;
	vector<glm::vec3> normals;
	vector<unsigned int> vIndex;
	vector<unsigned int> tIndex;
	vector<unsigned int> nIndex;
	vector<VertexTexture> data;
	int vertexCount;
	int textureCount;
	int indexCount;
	int normalsCount;
	Material materials;
	GLuint vbo;
	GLuint ibo;
	GLuint textureId;
	GLuint vertexArray = -1;
	GLuint textureArray = -1;
	GLuint colorArray = -1;
	GLuint normalArray = -1;
	bool LoadTextureFromFile();
	void decIndexes();
};