#include "Shader.h"

Shader::Shader()
{}

Shader::~Shader()
{}

bool Shader::LoadShader(const char* filename, int ShaderType)
{
	FILE *sh = fopen(filename, "rt");
	if (!sh)
		return false;
	int	lineCount = 0;
	GLchar buffer[255];
	while (!feof(sh))
	{
		fgets(buffer, 255, sh);
			lineCount++;
	}
	fseek(sh, 0L, SEEK_SET);
	GLchar *lines[128];
	
	for (auto i = 0; i < lineCount; i++)
	{
		lines[i] = new GLchar[255];
		fgets(buffer, 255, sh);
		strcpy(lines[i], buffer);
	}
	fclose(sh);
	
	switch (ShaderType)
	{
	case 1: shaderID = glCreateShader(GL_VERTEX_SHADER);
		break;
	case 2: shaderID = glCreateShader(GL_FRAGMENT_SHADER);
		break;
	default: return false;
		break;
	}
	type = ShaderType;
	glShaderSource(shaderID, lineCount, (const GLchar**)lines, nullptr);
	glCompileShader(shaderID);
	
	int iCompilationStatus, InfoLogLength;
	glGetShaderiv(shaderID, GL_COMPILE_STATUS, &iCompilationStatus);

	glGetShaderiv(shaderID, GL_COMPILE_STATUS, &iCompilationStatus);
	glGetShaderiv(shaderID, GL_INFO_LOG_LENGTH, &InfoLogLength);
	if (InfoLogLength > 0){
	 		std::vector<char> FragmentShaderErrorMessage(InfoLogLength + 1);
	 		glGetShaderInfoLog(shaderID, InfoLogLength, NULL, &FragmentShaderErrorMessage[0]);
	}

	if (iCompilationStatus == GL_FALSE)
		return false;
	return true;
}

bool Shader::AttachShader(GLuint *prog)
{
	glAttachShader(*prog, shaderID);
	return true;
}

GLuint Shader::GetShaderID()
{
	return shaderID;
}

int Shader::GetShaderType()
{
	return type;
}
