#pragma once
#include "dependences.h"
#include "types.h"

#include "Shader.h"
#include "Model.h"
#include "Camera.h"

class Render
{
public:
	Render();
	~Render();
	bool Init(HWND hwnd);
	void Run();
	void Shutdown(HWND hwnd);
	void PrepareScene();
	void SetData();
	void SetModelFile(string name);

	Model* GetModelByName(string name);
	Camera *cam;

	float rate;
	float delay;
	float cutWidth;
	float dz = 0.0f, dz2 = 0.0f;
private:
	GLuint CompileShader(char *file, int shaderType);
	HDC hdc;
	HGLRC hglrc;
	PIXELFORMATDESCRIPTOR pfd;
	GLuint program;
	GLuint VertexShader;
	GLuint FragmentShader;

	Shader *shaders;
	Model *models;


	GLuint vaoID;
	GLuint vertexbuffer;
	GLuint colorbuffer;
	GLuint vboID[3];

	GLuint Unif_mat;
	 
	PointLight pointLight;

	void StartCoordinate();
	void MatrixUpdate();

	glm::mat4 Matrix = glm::mat4();
	glm::mat4 Matrix2 = glm::mat4();
};

